Code

Updated si class
[gosa.git] / gosa-core / dh-make-gosa
1 #!/bin/sh
3 usage() {
4   echo "Usage: ${0##*/} [--download] [-b|--branch branch] [-e|--email mail] [--depends] plugin-dir|plugin.tar.gz" >&2
5   exit 1
6 }
9 load_dsc() {
10   if [[ -r "$1" ]]; then
11     PL_NAME=$(sed -n 's/"//g;s/^name\s*=\s*\(.*\)$/\1/p' "$1")
12     PL_VERSION=$(sed -n 's/"//g;s/^version\s*=\s*\(.*\)$/\1/p' "$1")
13     TDEPENDS=$(sed -n 's/"//g;s/^depends\s*=\s*\(.*\)$/\1/p' "$1")
14     for dep in $TDEPENDS; do
15       PL_DEPENDS="gosa-plugin-$dep, $PL_DEPENDS"
16     done
17     PL_DESCRIPTION=$(sed -n 's/"//g;s/^description\s*=\s*\(.*\)$/\1/p' "$1")
18     PL_AUTHOR=$(sed -n 's/"//g;s/^author\s*=\s*\([^<]*\).*$/\1/p' "$1")
19     PL_MAIL=$(sed -n 's/"//g;s/^author\s*=[^<].*<\([^>]*\).*$/\1/p' "$1")
20   else
21     echo "Error: cannot find description file" >&2
22     exit 1
23   fi
24 }
27 TEMP=`getopt -o e:r: --long download,release:,email:,depends: -n 'dh-make-gosa' -- "$@"`
28 if [[ $? != 0 ]] ; then
29   echo "Error: cannot get command line information" >&2
30   exit 1
31 fi
33 eval set -- "$TEMP"
35 # Load command  line vars
36 RELEASE=trunk
37 DOWNLOAD=
38 DEPENDS=
39 DEST=
40 while true; do
41   case "$1" in
42     -e|--email) DEBMAIL=$2
43                 shift 2
44                 ;;
45     -r|--release)
46                 if [[ "$2" != "trunk" ]]; then
47                   RELEASE=tags/$2
48                 fi
49                 shift 2
50                 ;;
51     --depends)  DEPENDS="$2"
52                 shift 2
53                 ;;
54     --dest)     DEST=$2/
55                 shift 2
56                 ;;
57     --download) DOWNLOAD=yes
58                 shift 1
59                 ;;
60     --)         shift
61                 break
62                 ;;
63     *)          usage
64                 ;;
65   esac
66 done
68 [[ $# -ne 1 ]] && usage
69 file=$*
71 # Three possiblities
72 if [[ -d "$file" ]]; then
74   # It's a local directory
75   load_dsc $file/plugin.dsc
77   # Setup build environment
78   BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
79   if [[ -d "$BUILD_PATH" ]]; then
80     echo "Error: build path $BUILD_PATH already exists" >&2
81     exit 2
82   fi
83   cp -a "$PL_NAME" "$BUILD_PATH"
85 elif [[ -f "$file" ]]; then
87   # It's a compressed user contributed file
88   TMPDIR="/tmp/dh-make-gosa-$PPID"
89   if [[ -d "/tmp/dh-make-gosa-$PPID"  ]]; then
90     echo "Error: directory $TMPDIR exists" >&2
91     exit 4
92   fi
94   # Untar
95   mkdir -p "$TMPDIR"
96   tar --extract --directory "$TMPDIR" -fz "$file" &> /dev/null
97   if [[ $? -ne 0 ]]; then
98     echo "Error: cannot extract plugin file - invalid file format" >&2
99     exit 5
100   fi
102   # It's a local directory
103   load_dsc TMPDIR/*/plugin.dsc
105   # Setup build environment
106   BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
107   mv "$TMPDIR/*" "$BUILD_PATH"
109 else
111   echo "Error: cannot find plugin $file" >&2
112   exit 5
114 fi
117 PL_DEPENDS=$(echo $PL_DEPENDS$DEPENDS | sed 's/,\s*$//')
118 echo "Debian package summary ========================================"
119 echo "Plugin:       $PL_NAME"
120 echo "Version:      $PL_VERSION"
121 echo "Description:  $PL_DESCRIPTION"
122 echo "Depends:      $PL_DEPENDS"
123 echo "Author name:  $PL_AUTHOR"
124 echo "Author email: $PL_MAIL"
125 echo
126 read -s -n 1 -p "Do you want to continue? (y/n)" ans; echo
127 [[ "$ans" != "y" ]] && exit 0
129 pushd . &> /dev/null
131 cd "$BUILD_PATH"
133 # Use gosa-plugin skelleton
134 echo "Calling dh_make..."
135 echo | dh_make -e "$PL_MAIL" -c gpl -s -n -f gosa-plugin-${PL_NAME}-${PL_VERSION}.tar.gz &> /dev/null
136 if [[ $? -ne 0 ]]; then
137         echo "Failed to call dh_make - aborting!"
138         exit 1
139 fi
141 echo "Apdapting debian descriptive files..."
142 # Generate install file
143 for dir in admin personal addons; do
144         [[ -d $dir ]] && echo -e "$dir\t\t\t/usr/share/gosa/plugins" > debian/install
145 done
146 for dir in help/*; do
147         echo -e "$dir\t\t\t/usr/share/gosa/plugins/$PL_NAME" >> debian/install
148 done
149 for dir in $(ls -1 locale | grep -v "^en$" | grep -v "^messages.po$"); do
150         echo -e "locale/$dir\t\t\t/usr/share/gosa/locale/plugins/$PL_NAME" >> debian/install
151 done
153 # Generate dirs
154 echo "usr/share/gosa" > debian/dirs
156 # Adapt control
157 sed -i 's/^Section: unknown/Section: web/g' debian/control
158 sed -i 's/^Depends: .*$/Depends: gosa/g' debian/control
159 sed -i "s/^Description: .*$/Description: $PL_NAME plugin for GOsa/g" debian/control
160 sed -i "s/^ <.*$/ $PL_DESCRIPTION\
161  .\
162  GOsa is a combination of system-administrator and end-user web\
163  interface, designed to handle LDAP based setups.\
164 /g" debian/control
166 # Adapt README.debian
167 cat <<EOF > debian/README.Debian
168 README.Debian for GOsa $PL_NAME plugin $PL_VERSION
169 -------------------------------------------
171 Please read the main GOsa README.Debian file for more information.
173 ----
174 $PL_AUTHOR <$PL_MAIL>  Fri 02 Jun 2006 16:23:50 +0200
175 EOF
177 # Fix rules
178 sed -i "/MAKE/d" debian/rules
179 sed -i "s/#.*dh_install$/\tdh_install/" debian/rules
181 # Adapt postinst/postrm
182 for file in postinst postrm; do
183 sed 's!#DEBHELPER#!#DEBHELPER#\
185 # Get apache versions running\
186 servers=""\
187 for srv in apache apache-ssl apache2; do\
188         if [[ -x /usr/sbin/$srv ]]; then\
189                 servers="$srv $servers"\
190         fi\
191 done\
193 # Update gosa\
194 /usr/sbin/update-gosa\
196 # Finally restart servers\
197 for server in $servers; do\
198         if [[ -x /usr/sbin/invoke-rc.d ]]; then\
199                 invoke-rc.d $server restart\
200         else\
201                 /etc/init.d/$server restart\
202         fi\
203 done\
205 !' debian/$file.ex > debian/$file
206 done
208 # Remove examples
209 rm debian/*ex debian/*EX &> /dev/null
211 popd &> /dev/null
213 echo "Done."